# ml-pronunciation

## Instalation

### Visual studio Dev Containers

```
sudo pip install -r requirements.txt

#if the folder is already there, skip this step
sudo git clone https://github.com/espeak-ng/espeak-ng.git

chmod 777 -R espeak-ng

cd espeak-ng && sudo ./autogen.sh && sudo ./configure && sudo make && sudo make install

sudo sh -c 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games:/usr/local/games:/snap/bin > /etc/environment'

sudo sh -c 'echo "LD_LIBRARY_PATH=/usr/local/lib" >> /etc/environment'

sudo sh -c 'echo "PKG_CONFIG_PATH=/usr/local/lib/pkgconfig" >> /etc/environment'

```

Arabic should be the in the output of the command:
`phonemize --list-languages`:

```
        af      ->      Afrikaans
        am      ->      Amharic
        an      ->      Aragonese
        ar      ->      Arabic
        as      ->      Assamese
        az      ->      Azerbaijani
        ba      ->      Bashkir
        be      ->      Belarusian
        bg      ->      Bulgarian
```
Google Translate Language Detection:

```
sudo apt-get install apt-transport-https ca-certificates gnupg

echo "deb [signed-by=/usr/share/keyrings/cloud.google.gpg] https://packages.cloud.google.com/apt cloud-sdk main" | sudo tee -a /etc/apt/sources.list.d/google-cloud-sdk.list

curl https://packages.cloud.google.com/apt/doc/apt-key.gpg | sudo apt-key --keyring /usr/share/keyrings/cloud.google.gpg add -

sudo apt-get update && sudo apt-get install google-cloud-cli

#this step needs an human action
gcloud init

#this step needs an human action
gcloud auth application-default login


```
 
### Local

```
python3.9 -m pip install --upgrade pip
pip3.9 install -r requirements.txt
brew install espeak
!git clone https://github.com/espeak-ng/espeak-ng.git
!chmod 777 -R espeak-ng
!cd espeak-ng && ./autogen.sh && ./configure && make && make install
# !echo "PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games:/usr/local/games:/snap/bin" > /etc/environment
!echo "LD_LIBRARY_PATH=/usr/local/lib" >> /etc/environment
!echo "PKG_CONFIG_PATH=/usr/local/lib/pkgconfig" >> /etc/environment
# !cat /etc/environment
!sudo ldconfig -v

```

If detecting language from text, Google Translate Language Detection Required

```
sudo apt-get install apt-transport-https ca-certificates gnupg
echo "deb [signed-by=/usr/share/keyrings/cloud.google.gpg] https://packages.cloud.google.com/apt cloud-sdk main" | sudo tee -a /etc/apt/sources.list.d/google-cloud-sdk.list
curl https://packages.cloud.google.com/apt/doc/apt-key.gpg | sudo apt-key --keyring /usr/share/keyrings/cloud.google.gpg add -
sudo apt-get update && sudo apt-get install google-cloud-cli
gcloud init
gcloud auth application-default login
```

## Usage

Iniciate the server:

```
python3.9 app.py
```

```
curl "http://localhost:5000/cmu_nc_map?word=bellesa&language=en"
```
